import { world, system } from "@minecraft/server";
    
function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('pa_spider_potions:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:fire_resistance", 9000, {amplifier: 1});
e.source.addEffect("minecraft:health_boost", 9000, {amplifier: 1});
e.source.addEffect("minecraft:instant_health", 2000, {amplifier: 1});
e.source.addEffect("minecraft:jump_boost", 9000, {amplifier: 1});
e.source.addEffect("minecraft:night_vision", 4000, {amplifier: 1});
e.source.addEffect("minecraft:slow_falling", 9000, {amplifier: 1});
e.source.addEffect("minecraft:speed", 4000, {amplifier: 1});
e.source.addEffect("minecraft:water_breathing", 4000, {amplifier: 1});
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:bad_omen");
e.source.removeEffect("minecraft:hunger");
e.source.removeEffect("minecraft:instant_damage");
e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:wither");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:slowness");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_spider_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_spider_pickaves:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
